/// <reference types="node" />
/// <reference types="express" />
import { Context } from '@loopback/context';
import { Server, Application } from '@loopback/core';
import * as express from 'express';
import * as http from 'http';
export declare class RPCServer extends Context implements Server {
    app: Application | undefined;
    config: RPCServerConfig | undefined;
    _server: http.Server;
    expressServer: express.Application;
    constructor(app?: Application | undefined, config?: RPCServerConfig | undefined);
    start(): Promise<void>;
    stop(): Promise<void>;
}
export declare type RPCServerConfig = {
    port?: number;
    [key: string]: any;
};
