"use strict";
// Copyright IBM Corp. 2018. All Rights Reserved.
// Node module: @loopback/example-rpc-server
// This file is licensed under the MIT License.
// License text available at https://opensource.org/licenses/MIT
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
const context_1 = require("@loopback/context");
const core_1 = require("@loopback/core");
const express = require("express");
const pEvent = require("p-event");
const rpc_router_1 = require("./rpc.router");
let RPCServer = class RPCServer extends context_1.Context {
    constructor(app, config) {
        super(app);
        this.app = app;
        this.config = config;
        this.config = config || {};
        this.expressServer = express();
        rpc_router_1.rpcRouter(this);
    }
    async start() {
        this._server = this.expressServer.listen((this.config && this.config.port) || 3000);
        return await pEvent(this._server, 'listening');
    }
    async stop() {
        this._server.close();
        return await pEvent(this._server, 'close');
    }
};
RPCServer = __decorate([
    __param(0, context_1.inject(core_1.CoreBindings.APPLICATION_INSTANCE)),
    __param(1, context_1.inject('rpcServer.config')),
    __metadata("design:paramtypes", [core_1.Application, Object])
], RPCServer);
exports.RPCServer = RPCServer;
//# sourceMappingURL=rpc.server.js.map